"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var react_1 = require("react");
var padStart_1 = __importDefault(require("lodash-es/padStart"));
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/icon/Icon"));
require("./TimeFieldView.scss");
function TimeFieldView(props) {
    var bem = hooks_1.useBem('TimeFieldView');
    var hours = react_1.useMemo(function () {
        var result = [];
        for (var i = 0; i < 24; i++) {
            var hour = padStart_1["default"](i, 2, '0');
            result.push(hour);
        }
        return result;
    }, []);
    var minutes = react_1.useMemo(function () {
        var result = [];
        for (var i = 0; i < 60; i++) {
            var minute = padStart_1["default"](i, 2, '0');
            result.push(minute);
        }
        return result;
    }, []);
    return (React.createElement("div", { ref: props.forwardedRef, className: bem(bem.block(), props.className), onFocus: function (e) {
            e.preventDefault();
            props.openDropDown();
        } },
        React.createElement("input", __assign({}, props.inputProps, { className: bem(bem.element('input', {
                size: props.size
            }), props.isInvalid && 'is-invalid'), autoComplete: 'off', disabled: props.disabled, placeholder: props.placeholder, required: props.required, type: props.type, onChange: function (e) { return props.inputProps.onChange(e.target.value); } })),
        React.createElement(Icon_1["default"], { className: bem.element('icon'), name: 'clock' }),
        props.showDropDown && (React.createElement("div", { className: bem.element('time-panel') },
            React.createElement("div", { className: bem.element('time-panel-body') },
                React.createElement("ul", { className: bem.element('time-panel-column') }, hours.map(function (value, index) { return (React.createElement("li", { key: index, className: bem.element('time-panel-cell'), onClick: function (e) { return props.changeHours(value); } },
                    React.createElement("div", { className: bem.element('time-panel-column-cell-value') }, value))); })),
                React.createElement("ul", { className: bem.element('time-panel-column') }, minutes.map(function (value, index) { return (React.createElement("li", { key: index, className: bem.element('time-panel-cell'), onClick: function (e) { return props.changeMinutes(value); } },
                    React.createElement("div", { className: bem.element('time-panel-column-cell-value') }, value))); }))),
            React.createElement("div", { className: bem.element('time-panel-footer') },
                React.createElement("button", null, "Ok"))))));
}
exports["default"] = TimeFieldView;
